// mfcapp.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "mfcapp.h"
#include "MainFrm.h"

#ifdef _DEBUG
//#define new DEBUG_NEW
#endif

#include <Windows4Root.h>
#include <TApplication.h>
#include <TSystem.h>
#include <TCanvas.h>
#include <TVirtualX.h>

// CmfcappApp

BEGIN_MESSAGE_MAP(CmfcappApp, CWinApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
END_MESSAGE_MAP()

TApplication *gMFCRootApp;
// a global canvas for the drawing of histograms
TCanvas *c;

// CmfcappApp construction

CmfcappApp::CmfcappApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
   int argc = 1;
   char *argv[] = {
      "mfcapp.exe",
      NULL
   };
   gMFCRootApp = new TApplication("MFC ROOT Application", &argc, argv);
   gMFCRootApp->SetReturnFromRun(true);
}

CmfcappApp::~CmfcappApp()
{
   delete gMFCRootApp;
}


// The one and only CmfcappApp object

CmfcappApp theApp;

// CmfcappApp initialization

BOOL CmfcappApp::InitInstance()
{
	// InitCommonControls() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	InitCommonControls();

	CWinApp::InitInstance();

   // Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));
	// To create the main window, this code creates a new frame window
	// object and then sets it as the application's main window object
	CMainFrame* pFrame = new CMainFrame;
	if (!pFrame)
		return FALSE;
	m_pMainWnd = pFrame;
	// create and load the frame with its resources
	pFrame->LoadFrame(IDR_MAINFRAME,
		WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE, NULL,
		NULL);
	// The one and only window has been initialized, so show and update it
	pFrame->ShowWindow(SW_SHOW);
	pFrame->UpdateWindow();

	// call DragAcceptFiles only if there's a suffix
	//  In an SDI app, this should occur after ProcessShellCommand
	return TRUE;
}


// CmfcappApp message handlers



// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

// App command to run the dialog
void CmfcappApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}


// CmfcappApp message handlers

BOOL CmfcappApp::OnIdle(LONG lCount)
{
   while(gVirtualX->EventsPending()) {
      gSystem->ProcessEvents();
   }
   SleepEx(10, TRUE);
   gSystem->ProcessEvents();
   return TRUE;
}
